#ifndef MAIN_WINDOW_H
#define MAIN_WINDOW_H

#include <QListWidget>
#include <QMainWindow>

#include <comdel/display/library_display.h>
#include <comdel/display/schema_display.h>

#include <comdel/domain/library.h>
#include <comdel/domain/schema.h>

QT_BEGIN_NAMESPACE
namespace Ui { class MainWindow; }
QT_END_NAMESPACE

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    MainWindow(QWidget *parent = nullptr);
    ~MainWindow();

    display::Library *libraryDisplay;
    display::Schema *schemaDisplay;

    std::optional<domain::Library> library = std::nullopt;
    std::optional<domain::Schema> schema = std::nullopt;

    std::vector<domain::FunctionSignature> signatures;

    void setupUi();
    void clear();

private slots:
    void onLoadLibrary();
    void onLoadSchema();
    void onTestModal();

private:
    Ui::MainWindow *ui;
};
#endif // MAIN_WINDOW_H
